<?php
namespace Teknisa\CUS\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class Cus00100 extends \Zeedhi\Framework\Controller\Report {

    protected $novoCodigo;
    protected $procedureConsumoPlanejado;
    protected $consplan;
    protected $servicoPorGrupo;
    protected $qr2Strategy;
    protected $nrorg;
    protected $cdfilial;
    protected $nrConsPlan;
    protected $birtStrategy;
    protected $Listas;

    public function __construct($reportService, $novoCodigo, StoredProcedure $procedureConsumoPlanejado, $consplan, $qr2Strategy, $servicoPorGrupo, $birtStrategy, $Listas) {
      $this->novoCodigo                 = $novoCodigo;
      $this->procedureConsumoPlanejado  = $procedureConsumoPlanejado;
      $this->consplan                   = $consplan;
      $this->qr2Strategy                = $qr2Strategy;
      $this->servicoPorGrupo            = $servicoPorGrupo;
      $this->reportService              = $reportService;
      $this->birtStrategy              = $birtStrategy;
      $this->Listas                    = $Listas;
    }

    protected $reportMapping = array (
      'CUS00100' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' => 
        array (
          'CDFILIAL'    => 'P_CDFILIAL',
          'NRCONSPLAN'  => 'P_NRCONSPLAN',
          'DTINICIAL'   => 'P_DTINICIAL',
          'DTFINAL'     => 'P_DTFINAL',
          'LISTASERV'   => 'P_CDSERVFILI',
          'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
          'NMTIPOCUSTO' => 'P_NMCUSTO',
          'RADIO_DATA'  => 'P_TPDTCUS',
          'NRORG'       => 'P_NRORG'
        )
      ),
      'CUS00101' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' => 
        array (
          'CDFILIAL'    => 'P_CDFILIAL',
          'NRCONSPLAN'  => 'P_NRCONSPLAN',
          'LISTASERV'   => 'P_CDSERVFILI',
          'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
          'NMTIPOCUSTO' => 'P_NMCUSTO',
          'DTINICIAL'   => 'P_DTINICIAL',
          'DTFINAL'     => 'P_DTFINAL',
          'RADIO_DATA'  => 'P_TPDTCUS',
          'NRORG'       => 'P_NRORG'
        )
      ),
      'CUS00102' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' => 
        array (
          'CDFILIAL'    => 'P_CDFILIAL',
          'NRCONSPLAN'  => 'P_NRCONSPLAN',
          'LISTASERV'   => 'P_CDSERVFILI',
          'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
          'NMTIPOCUSTO' => 'P_NMCUSTO',
          'DTINICIAL'   => 'P_DTINICIAL',
          'DTFINAL'     => 'P_DTFINAL',
          'RADIO_DATA'  => 'P_TPDTCUS',
          'NRORG'       => 'P_NRORG'
        )
      ),
      'CUS00103' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' => 
        array (
          'CDFILIAL'    => 'P_CDFILIAL',
          'NRCONSPLAN'  => 'P_NRCONSPLAN',
          'LISTASERV'   => 'P_CDSERVFILI',
          'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
          'NMTIPOCUSTO' => 'P_NMCUSTO',
          'DTINICIAL'   => 'P_DTINICIAL',
          'DTFINAL'     => 'P_DTFINAL',
          'RADIO_DATA'  => 'P_TPDTCUS',
          'NRORG'       => 'P_NRORG'
        )
      ),
      'CUS00106' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' => 
        array (
          'CDFILIAL'    => 'P_CDFILIAL',
          'NRCONSPLAN'  => 'P_NRCONSPLAN',
          'LISTASERV'   => 'P_CDSERVFILI',
          'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
          'NMTIPOCUSTO' => 'P_NMCUSTO',
          'DTINICIAL'   => 'P_DTINICIAL',
          'DTFINAL'     => 'P_DTFINAL',
          'RADIO_DATA'  => 'P_TPDTCUS',
          'NRORG'       => 'P_NRORG' 
        )
      ),
      'CUS00107' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' => 
        array (
          'CDFILIAL'    => 'P_CDFILIAL',
          'NRCONSPLAN'  => 'P_NRCONSPLAN',
          'LISTASERV'   => 'P_CDSERVFILI',
          'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
          'NMTIPOCUSTO' => 'P_NMCUSTO',
          'DTINICIAL'   => 'P_DTINICIAL',
          'DTFINAL'     => 'P_DTFINAL',
          'RADIO_DATA'  => 'P_TPDTCUS',
          'NRORG'       => 'P_NRORG'
        )
      ),
      'CUS00108' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' => 
        array (
          'CDFILIAL'    => 'P_CDFILIAL',
          'NRCONSPLAN'  => 'P_NRCONSPLAN',
          'LISTASERV'   => 'P_CDSERVFILI',
          'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
          'NMTIPOCUSTO' => 'P_NMCUSTO',
          'DTINICIAL'   => 'P_DTINICIAL',
          'DTFINAL'     => 'P_DTFINAL',
          'RADIO_DATA'  => 'P_TPDTCUS',
          'NRORG'       => 'P_NRORG' 
        )
      ),
      'CUS0010A' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' => 
        array (
          "CDTIPOCUSTO" => "P_NRTIPOCUSTO",
          "RADIO_DATA" => "P_TPDTCUS",
          "COMPRADORES" => "P_COMPRADORES",
          "NMTIPOCUSTO" => "P_NMCUSTO",
          "CDARVPRODINI" => "P_CDPRODINI",
          "CDARVPRODFIN" => "P_CDPRODFIN",
          "CDFILIAL" => "P_CDFILIAL",
          "NRCONSPLAN" => "P_NRCONSPLAN",
          "SERVICOS" => "P_CDSERVFILI",
          "DTINICIAL" => "P_DTINICIAL",
          "DTFINAL" => "P_DTFINAL",
          "NRORG" => "P_NRORG"
        )
      )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {

        $row = $request->getRow();
        $explodeNmTipoCusto = explode('| ', $row['NMTIPOCUSTO']);
        $row['NMTIPOCUSTO'] = $explodeNmTipoCusto[1];

        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        
        
        $dateInicialFormatted = \DateTime::createFromFormat('d/m/Y', $row['DTINICIAL']);
        $dateInicial          = $row['DTINICIAL'];
        $dateFinalFormatted   = \DateTime::createFromFormat('d/m/Y', $row['DTFINAL']);
        $dateFinal            = $row['DTFINAL'];
        $cdfilial             = $row['CDFILIAL'];

        $idArquivo            = "T";
        $idProdutos           = "CFP";
        $idSepPrato           = "P";
        $peAcrescimo          = 0;
        $idarredond           = "N";
        $cdProdutoIni         = ' ';
        $cdProdutoFin         = "zzzzzzzzzz";

        $cdoperador           = $row['CDOPERADOR'];
        $nrorg                = $row['NRORG'];
        $cdgrupserv           = $row['LISTAGRUPSERV'];
        
        if (($row['LISTASERV'] == 'REQUEST') || ($row['CD_REPORT_NAME'] == "Cus00108")) {
            $row['LISTASERV'] = $this->servicoPorGrupo->retornaServicosPorGrupo($nrorg, $cdfilial, $cdoperador, $cdgrupserv);
        }
        $nrConsPlan = $this->novoCodigo->getCodeByTableName('CONSPLAN'.$cdfilial, $nrorg);
        $this->procedureConsumoPlanejado->addParam(new Param('P_FILIAL',        Param::PARAM_INPUT, $cdfilial,          Param::PARAM_TYPE_STR));
        $this->procedureConsumoPlanejado->addParam(new Param('P_SERVICOS',      Param::PARAM_INPUT, $row['LISTASERV'],  Param::PARAM_TYPE_STR));
        $this->procedureConsumoPlanejado->addParam(new Param('P_DTINICIAL',     Param::PARAM_INPUT, $dateInicial,       Param::PARAM_TYPE_STR));
        $this->procedureConsumoPlanejado->addParam(new Param('P_DTFINAL',       Param::PARAM_INPUT, $dateFinal,         Param::PARAM_TYPE_STR));
        $this->procedureConsumoPlanejado->addParam(new Param('P_IDARQUIVO',     Param::PARAM_INPUT, $idArquivo,         Param::PARAM_TYPE_STR));
        $this->procedureConsumoPlanejado->addParam(new Param('P_IDPRODUTOS',    Param::PARAM_INPUT, $idProdutos,        Param::PARAM_TYPE_STR));
        $this->procedureConsumoPlanejado->addParam(new Param('P_IDSEPPRATO',    Param::PARAM_INPUT, $idSepPrato,        Param::PARAM_TYPE_STR));
        $this->procedureConsumoPlanejado->addParam(new Param('P_PEACRESCIMO',   Param::PARAM_INPUT, $peAcrescimo,       Param::PARAM_TYPE_INT));
        $this->procedureConsumoPlanejado->addParam(new Param('P_IDARREDOND',    Param::PARAM_INPUT, $idarredond,        Param::PARAM_TYPE_STR));
        $this->procedureConsumoPlanejado->addParam(new Param('P_NRCONSPLAN',    Param::PARAM_INPUT, $nrConsPlan,        Param::PARAM_TYPE_STR));
        $this->procedureConsumoPlanejado->addParam(new Param('P_CDPRODUTOINI',  Param::PARAM_INPUT, $cdProdutoIni,      Param::PARAM_TYPE_STR));
        $this->procedureConsumoPlanejado->addParam(new Param('P_CDPRODUTOFIN',  Param::PARAM_INPUT, $cdProdutoFin,      Param::PARAM_TYPE_STR));
        $this->procedureConsumoPlanejado->addParam(new Param('P_CDOPERADOR',    Param::PARAM_INPUT, $cdoperador,        Param::PARAM_TYPE_STR));
        $this->procedureConsumoPlanejado->addParam(new Param('P_STDTINICIAL',   Param::PARAM_INPUT, "_".$dateInicialFormatted->format('Ymd')."_", Param::PARAM_TYPE_STR));
        $this->procedureConsumoPlanejado->addParam(new Param('P_STDTFINAL',     Param::PARAM_INPUT, "_".$dateFinalFormatted->format('Ymd')."_",   Param::PARAM_TYPE_STR));

        $resultado         = $this->procedureConsumoPlanejado->execute();
        $novoCodigoLista   = $this->novoCodigo->getCodeByTableName('LISTA', $nrorg);

        $row['NRCONSPLAN'] = $nrConsPlan;
        $row['NRLISTA']    = $novoCodigoLista;
        $this->nrorg       = $nrorg;
        $this->cdfilial    = $cdfilial;
        $this->nrConsPlan  = $nrConsPlan;
        
        if ($row['CD_REPORT_NAME'] == "CUS0010A") {
          $row["COMPRADORES"] = $this->Listas->criarListaValores($row["COMPRADORES"]);
          $row["SERVICOS"] = "_NRLISTA=" . $this->servicoPorGrupo->retornaServicosPorGrupo($nrorg, $cdfilial, $cdoperador, $cdgrupserv);
          $row["CDARVPRODINI"] = isset($row["CDARVPRODINI"]) ? $row["CDARVPRODINI"] : "0";
          $row["CDARVPRODFIN"] = isset($row["CDARVPRODFIN"]) ? $row["CDARVPRODFIN"].'zzzzzzzzzzzzzzzzzzzz' : "zzzzzzzzzzzzzzzzzzzz";
        }
      }
  
    public function afterProcessReport(DTO\Request\Row $request, DTO\Response $response, $report) {
        $parametros = array(
            "NRORG"      => $this->nrorg, 
            "CDFILICPLA" => $this->cdfilial, 
            "NRCONSPLAN" => $this->nrConsPlan, 
            "__is_new"   => false
        );
        $newRequest = new DTO\Request\Row($parametros, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        $newResponse = new DTO\Response();
        $this->consplan->delete($newRequest, $newResponse);
    }
}